#pragma once

#include "list.hpp"

// entry
template<int Key, int Value>
struct entry {
	enum {
		key = Key,
		value = Value
	}; 
};

// dictionary
template<typename Entry, typename Rest>
struct dictionary {
	typedef Entry entry;
	typedef Rest tail;
};

// at_key
template<typename Dict, int Key>
struct at_key;

template<int Key>
struct at_key<nil, Key> { 
	enum { value = 0 }; 
};

template<int Key, int Value, typename Dict>
struct at_key<
	dictionary<
		entry<Key, Value>,
		Dict
	>,
	Key
	> { 
	enum { value = Value }; 
};

template<int Key, typename OtherEntry, typename Dict>	
struct at_key<
	dictionary<OtherEntry, Dict>,
	Key
	> {
	enum { value = at_key<Dict, Key>::value }; 
};

// set_value
template<typename Dict, int Key, int Value>	
struct set_value;

template<int Key, int Value>	
struct set_value<nil, Key, Value> {
	typedef dictionary<
		entry<Key, Value>,
		nil
	> value;
};

template<int Key, int OtherValue, int Value, typename Dict>
struct set_value<
	dictionary<
		entry<Key, OtherValue>,
		Dict>,
	Key,
	Value> {
	typedef dictionary<
		entry<Key, Value>,
		Dict
	> value;
};

template<int Key, int Value, typename OtherEntry, typename Dict>	
struct set_value<
	dictionary<OtherEntry, Dict>,
	Key,
	Value> {
	typedef dictionary<
		OtherEntry,
		typename set_value<Dict, Key, Value>::value
	> value;
};



